From be1403cb8d915b023b6d15e792d3d97dbafceb39 Mon Sep 17 00:00:00 2001
From: "H.J. Lu" <hjl.tools@gmail.com>
Date: Wed, 25 Nov 2015 12:14:05 -0800
Subject: [PATCH] Update TARGET_FUNCTION_INCOMING_ARG documentation

On x86, interrupt handlers are only called by processors which push
interrupt data onto stack at the address where the normal return address
is.  Since interrupt handlers must access interrupt data via pointers so
that they can update interrupt data, the pointer argument is passed as
"argument pointer - word".

TARGET_FUNCTION_INCOMING_ARG defines how callee sees its argument.
Normally it returns REG, NULL, or CONST_INT.  This patch adds arbitrary
address computation based on hard register, which can be forced into a
register, to the list.

When copying an incoming argument onto stack, assign_parm_setup_stack
has:

if (argument in memory)
  copy argument in memory to stack
else
  move argument to stack

Since an arbitrary address computation may be passed as an argument, we
change it to:

if (argument in memory)
  copy argument in memory to stack
else
  {
    if (argument isn't in register)
      force argument into a register
    move argument to stack
  }

	* function.c (assign_parm_setup_stack): Force source into a
	register if needed.
	* target.def (function_incoming_arg): Update documentation to
	allow arbitrary address computation based on hard register.
	* doc/tm.texi: Regenerated.

Implement x86 interrupt attribute

The interrupt and exception handlers are called by x86 processors.  X86
hardware pushes information onto stack and calls the handler.  The
requirements are

1. Both interrupt and exception handlers must use the 'IRET' instruction,
instead of the 'RET' instruction, to return from the handlers.
2. All registers are callee-saved in interrupt and exception handlers.
3. The difference between interrupt and exception handlers is the
exception handler must pop 'ERROR_CODE' off the stack before the 'IRET'
instruction.

The design goals of interrupt and exception handlers for x86 processors
are:

1. Support both 32-bit and 64-bit modes.
2. Flexible for compilers to optimize.
3. Easy to use by programmers.

To implement interrupt and exception handlers for x86 processors, a
compiler should support:

'interrupt' attribute

Use this attribute to indicate that the specified function with
mandatory arguments is an interrupt or exception handler.  The compiler
generates function entry and exit sequences suitable for use in an
interrupt handler when this attribute is present.  The 'IRET' instruction,
instead of the 'RET' instruction, is used to return from interrupt or
exception handlers.  All registers, except for the EFLAGS register which
is restored by the 'IRET' instruction, are preserved by the compiler.

Any interruptible-without-stack-switch code must be compiled with
-mno-red-zone since interrupt handlers can and will, because of the
hardware design, touch the red zone.

1. interrupt handler must be declared with a mandatory pointer argument:

struct interrupt_frame;

__attribute__ ((interrupt))
void
f (struct interrupt_frame *frame)
{
...
}

and user must properly define the structure the pointer pointing to.

2. exception handler:

The exception handler is very similar to the interrupt handler with
a different mandatory function signature:

typedef unsigned int uword_t __attribute__ ((mode (__word__)));

struct interrupt_frame;

__attribute__ ((interrupt))
void
f (struct interrupt_frame *frame, uword_t error_code)
{
...
}

and compiler pops the error code off stack before the 'IRET' instruction.

The exception handler should only be used for exceptions which push an
error code and all other exceptions must use the interrupt handler.
The system will crash if the wrong handler is used.

To be feature complete, compiler may implement the optional
'no_caller_saved_registers' attribute:

Use this attribute to indicate that the specified function has no
caller-saved registers.  That is, all registers are callee-saved.
The compiler generates proper function entry and exit sequences to
save and restore any modified registers.

The user can call functions specified with 'no_caller_saved_registers'
attribute from an interrupt handler without saving and restoring all
call clobbered registers.

On x86, interrupt handlers are only called by processors which push
interrupt data onto stack at the address where the normal return address
is.  Interrupt handlers must access interrupt data via pointers so that
they can update interrupt data.

gcc/

	PR target/66960
	PR target/67630
	PR target/67634
	PR target/67841
	PR target/68037
	PR target/68618
	PR target/68661
	* config/i386/i386-protos.h (ix86_epilogue_uses): New prototype.
	* config/i386/i386.c (ix86_frame): Add nbndregs, nmaskregs,
	bnd_reg_save_offset and mask_reg_save_offset.
	(ix86_conditional_register_usage): Preserve all registers,
	except for function return registers if there are no caller-saved
	registers.
	(ix86_set_current_function): Set no_caller_saved_registers and
	func_type.  Sorry if non-DWARF debug format is used.  Call
	reinit_regs if caller-saved registers are changed.
	(ix86_function_ok_for_sibcall): Return false if there are no
	caller-saved registers.
	(type_natural_mode): Don't warn ABI change for MMX in interrupt
	handler.
	(ix86_function_arg_advance): Skip for callee in interrupt
	handler.
	(ix86_function_arg): Return special arguments in interrupt
	handler.
	(ix86_promote_function_mode): Promote pointer to word_mode only
	for normal functions.
	(ix86_can_use_return_insn_p): Don't use `ret' instruction in
	interrupt handler.
	(ix86_epilogue_uses): New function.
	(ix86_hard_regno_scratch_ok): Likewise.
	(ix86_nsaved_bndregs): Likewise.
	(ix86_nsaved_maskregs): Likewise.
	(ix86_emit_save_bnd_regs_using_mov): Likewise.
	(ix86_emit_save_mask_regs_using_mov): Likewise.
	(ix86_emit_restore_bnd_regs_using_mov): Likewise.
	(ix86_emit_restore_mask_regs_using_mov): Likewise.
	(ix86_handle_no_caller_saved_registers_attribute): Likewise.
	(ix86_handle_interrupt_attribute): Likewise.
	(ix86_save_reg): Preserve all registers in interrupt function
	after reload.  Preserve all registers, except for function
	return registers, if there are no caller-saved registers after
	reload.
	(ix86_nsaved_sseregs): Don't return 0 if there are no
	caller-saved registers.
	(ix86_compute_frame_layout): Set nbndregs and nmaskregs.  Set
	and allocate BND and MASK register save areas.  Allocate space to
	save full vector registers if there are no caller-saved registers.
	(ix86_emit_save_reg_using_mov): Don't use UNSPEC_STOREU to
	SSE registers.
	(ix86_emit_save_sse_regs_using_mov): Save full vector registers
	if there are no caller-saved registers.
	(find_drap_reg): Always use callee-saved register if there are
	no caller-saved registers.
	(ix86_minimum_incoming_stack_boundary): Return MIN_STACK_BOUNDARY
	for interrupt handler.
	(ix86_expand_prologue): Save BND and MASK registers.
	(ix86_emit_restore_sse_regs_using_mov): Restore full vector
	registers if there are no caller-saved registers.
	(ix86_expand_epilogue): Restore BND and MASK registers.  Generate
	interrupt return for interrupt handler and pop the 'ERROR_CODE'
	off the stack before interrupt return in exception handler.
	(ix86_expand_move): Disallow 80387 instructions in exception
	handler.
	(ix86_expand_vector_move): Disallow MMX/3Dnow instructions in
	exception handler.
	(ix86_expand_call): Disallow calling interrupt handler directly.
	If there are no caller-saved registers, mark all registers that
	are clobbered by the call which returns as clobbered.
	(ix86_attribute_table): Add interrupt and no_caller_saved_registers
	attributes.
	(TARGET_HARD_REGNO_SCRATCH_OK): Likewise.
	* config/i386/i386.h (ACCUMULATE_OUTGOING_ARGS): Use argument
	accumulation in interrupt function if stack may be realigned to
	avoid DRAP.
	(EPILOGUE_USES): New.
	(function_type): New enum.
	(machine_function): Add func_type and no_caller_saved_registers.
	* config/i386/i386.md (UNSPEC_INTERRUPT_RETURN): New.
	(interrupt_return): New pattern.
	* doc/extend.texi: Document x86 interrupt and
	no_caller_saved_registers attributes.

gcc/testsuite/

	PR target/66960
	PR target/67630
	PR target/67634
	PR target/67841
	PR target/68037
	PR target/68618
	PR target/68661
	* gcc.dg/guality/pr68037-1.c: New test.
	* gcc.dg/guality/pr68037-2.c: Likewise.
	* gcc.dg/guality/pr68037-3.c: Likewise.
	* gcc.dg/torture/pr68037-1.c: Likewise.
	* gcc.dg/torture/pr68037-2.c: Likewise.
	* gcc.dg/torture/pr68037-3.c: Likewise.
	* gcc.dg/torture/pr68661-1a.c: Likewise.
	* gcc.dg/torture/pr68661-1b.c: Likewise.
	* gcc.target/i386/interrupt-1.c: Likewise.
	* gcc.target/i386/interrupt-2.c: Likewise.
	* gcc.target/i386/interrupt-3.c: Likewise.
	* gcc.target/i386/interrupt-4.c: Likewise.
	* gcc.target/i386/interrupt-5.c: Likewise.
	* gcc.target/i386/interrupt-6.c: Likewise.
	* gcc.target/i386/interrupt-7.c: Likewise.
	* gcc.target/i386/interrupt-8.c: Likewise.
	* gcc.target/i386/interrupt-9.c: Likewise.
	* gcc.target/i386/interrupt-10.c: Likewise.
	* gcc.target/i386/interrupt-11.c: Likewise.
	* gcc.target/i386/interrupt-12.c: Likewise.
	* gcc.target/i386/interrupt-13.c: Likewise.
	* gcc.target/i386/interrupt-14.c: Likewise.
	* gcc.target/i386/interrupt-15.c: Likewise.
	* gcc.target/i386/interrupt-16.c: Likewise.
	* gcc.target/i386/interrupt-17.c: Likewise.
	* gcc.target/i386/interrupt-18.c: Likewise.
	* gcc.target/i386/interrupt-19.c: Likewise.
	* gcc.target/i386/interrupt-20.c: Likewise.
	* gcc.target/i386/interrupt-21.c: Likewise.
	* gcc.target/i386/interrupt-22.c: Likewise.
	* gcc.target/i386/interrupt-23.c: Likewise.
	* gcc.target/i386/interrupt-24.c: Likewise.
	* gcc.target/i386/interrupt-25.c: Likewise.
	* gcc.target/i386/interrupt-26.c: Likewise.
	* gcc.target/i386/interrupt-27.c: Likewise.
	* gcc.target/i386/interrupt-28.c: Likewise.
	* gcc.target/i386/interrupt-29.c: Likewise.
	* gcc.target/i386/interrupt-30.c: Likewise.
	* gcc.target/i386/interrupt-31.c: Likewise.
	* gcc.target/i386/interrupt-32.c: Likewise.
	* gcc.target/i386/interrupt-33.c: Likewise.
	* gcc.target/i386/interrupt-34.c: Likewise.
	* gcc.target/i386/interrupt-35.c: Likewise.
	* gcc.target/i386/interrupt-387-err.c: Likewise.
	* gcc.target/i386/interrupt-bnd.c: Likewise.
	* gcc.target/i386/interrupt-iamcu.c: Likewise.
	* gcc.target/i386/interrupt-mmx-err.c: Likewise.
	* gcc.target/i386/interrupt-redzone-1.c: Likewise.
	* gcc.target/i386/interrupt-redzone-2.c: Likewise.
	* gcc.target/i386/interrupt-sibcall-1.c: Likewise.
	* gcc.target/i386/interrupt-sibcall-2.c: Likewise.
	* gcc.target/i386/interrupt-switch-abi.c: Likewise.
	* gcc.target/i386/interrupt-xmm.c: Likewise.
	* gcc.target/i386/interrupt-ymm.c: Likewise.
	* gcc.target/i386/interrupt-zmm.c: Likewise.

Rebuild array with the updated function pointer type

When we apply function attribute to array of function pointer, we need
to rebuild array with the updated function pointer type.

gcc/

	PR c/68637
	* attribs.c (decl_attributes): Rebuild array with the updated
	function pointer type.

gcc/testsuite/

	PR c/68637
	* gcc.target/i386/pr68637-1.c: New test.
	* gcc.target/i386/pr68637-2.c: Likewise.

Add an array of function pointer test for PR 68661

Array of function pointer with no_caller_saved_registers attribute only
works if PR c/68637 is fixed.

	PR target/68637
	PR target/68661
	* gcc.dg/torture/pr68661-2a.c: Likewise.
	* gcc.dg/torture/pr68661-2b.c: Likewise.
---
 gcc/attribs.c                                      |  18 +-
 gcc/config/i386/i386-protos.h                      |   2 +
 gcc/config/i386/i386.c                             | 589 +++++++++++++++++++--
 gcc/config/i386/i386.h                             |  37 +-
 gcc/config/i386/i386.md                            |   9 +
 gcc/doc/extend.texi                                |  63 +++
 gcc/doc/tm.texi                                    |   4 +
 gcc/function.c                                     |   6 +-
 gcc/target.def                                     |   8 +-
 gcc/testsuite/gcc.dg/guality/pr68037-1.c           |  65 +++
 gcc/testsuite/gcc.dg/guality/pr68037-2.c           |  60 +++
 gcc/testsuite/gcc.dg/guality/pr68037-3.c           |  76 +++
 gcc/testsuite/gcc.dg/torture/pr68037-1.c           |  57 ++
 gcc/testsuite/gcc.dg/torture/pr68037-2.c           |  53 ++
 gcc/testsuite/gcc.dg/torture/pr68037-3.c           |  69 +++
 gcc/testsuite/gcc.dg/torture/pr68661-1a.c          |  17 +
 gcc/testsuite/gcc.dg/torture/pr68661-1b.c          |  44 ++
 gcc/testsuite/gcc.dg/torture/pr68661-2a.c          |  17 +
 gcc/testsuite/gcc.dg/torture/pr68661-2b.c          |  52 ++
 gcc/testsuite/gcc.target/i386/interrupt-1.c        |  53 ++
 gcc/testsuite/gcc.target/i386/interrupt-10.c       |  24 +
 gcc/testsuite/gcc.target/i386/interrupt-11.c       |  37 ++
 gcc/testsuite/gcc.target/i386/interrupt-12.c       |  20 +
 gcc/testsuite/gcc.target/i386/interrupt-13.c       |  17 +
 gcc/testsuite/gcc.target/i386/interrupt-14.c       |  39 ++
 gcc/testsuite/gcc.target/i386/interrupt-15.c       |  28 +
 gcc/testsuite/gcc.target/i386/interrupt-16.c       |  28 +
 gcc/testsuite/gcc.target/i386/interrupt-17.c       |  30 ++
 gcc/testsuite/gcc.target/i386/interrupt-18.c       |  35 ++
 gcc/testsuite/gcc.target/i386/interrupt-19.c       |  21 +
 gcc/testsuite/gcc.target/i386/interrupt-2.c        |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-20.c       |  22 +
 gcc/testsuite/gcc.target/i386/interrupt-21.c       |  25 +
 gcc/testsuite/gcc.target/i386/interrupt-22.c       |  25 +
 gcc/testsuite/gcc.target/i386/interrupt-23.c       |  25 +
 gcc/testsuite/gcc.target/i386/interrupt-24.c       |  21 +
 gcc/testsuite/gcc.target/i386/interrupt-25.c       |  24 +
 gcc/testsuite/gcc.target/i386/interrupt-26.c       |  11 +
 gcc/testsuite/gcc.target/i386/interrupt-27.c       |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-28.c       |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-29.c       |  27 +
 gcc/testsuite/gcc.target/i386/interrupt-3.c        |  14 +
 gcc/testsuite/gcc.target/i386/interrupt-30.c       |  28 +
 gcc/testsuite/gcc.target/i386/interrupt-31.c       |  27 +
 gcc/testsuite/gcc.target/i386/interrupt-32.c       |  42 ++
 gcc/testsuite/gcc.target/i386/interrupt-33.c       |  19 +
 gcc/testsuite/gcc.target/i386/interrupt-34.c       |  15 +
 gcc/testsuite/gcc.target/i386/interrupt-35.c       |  54 ++
 gcc/testsuite/gcc.target/i386/interrupt-387-err.c  |  27 +
 gcc/testsuite/gcc.target/i386/interrupt-4.c        |  32 ++
 gcc/testsuite/gcc.target/i386/interrupt-5.c        |  23 +
 gcc/testsuite/gcc.target/i386/interrupt-6.c        |  40 ++
 gcc/testsuite/gcc.target/i386/interrupt-7.c        |  12 +
 gcc/testsuite/gcc.target/i386/interrupt-8.c        |  20 +
 gcc/testsuite/gcc.target/i386/interrupt-9.c        |  22 +
 gcc/testsuite/gcc.target/i386/interrupt-bnd.c      |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-iamcu.c    |  35 ++
 gcc/testsuite/gcc.target/i386/interrupt-mmx-err.c  |  37 ++
 .../gcc.target/i386/interrupt-redzone-1.c          |  31 ++
 .../gcc.target/i386/interrupt-redzone-2.c          |  32 ++
 .../gcc.target/i386/interrupt-sibcall-1.c          |  12 +
 .../gcc.target/i386/interrupt-sibcall-2.c          |  13 +
 .../gcc.target/i386/interrupt-switch-abi.c         |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-xmm.c      |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-ymm.c      |  16 +
 gcc/testsuite/gcc.target/i386/interrupt-zmm.c      |  16 +
 gcc/testsuite/gcc.target/i386/pr68637-1.c          |  10 +
 gcc/testsuite/gcc.target/i386/pr68637-2.c          |  25 +
 68 files changed, 2411 insertions(+), 45 deletions(-)
 create mode 100644 gcc/testsuite/gcc.dg/guality/pr68037-1.c
 create mode 100644 gcc/testsuite/gcc.dg/guality/pr68037-2.c
 create mode 100644 gcc/testsuite/gcc.dg/guality/pr68037-3.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68037-1.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68037-2.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68037-3.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68661-1a.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68661-1b.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68661-2a.c
 create mode 100644 gcc/testsuite/gcc.dg/torture/pr68661-2b.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-1.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-10.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-11.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-12.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-13.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-14.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-15.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-16.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-17.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-18.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-19.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-2.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-20.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-21.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-22.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-23.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-24.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-25.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-26.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-27.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-28.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-29.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-3.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-30.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-31.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-32.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-33.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-34.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-35.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-387-err.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-4.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-5.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-6.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-7.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-8.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-9.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-bnd.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-iamcu.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-mmx-err.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-redzone-1.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-redzone-2.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-sibcall-1.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-sibcall-2.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-switch-abi.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-xmm.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-ymm.c
 create mode 100644 gcc/testsuite/gcc.target/i386/interrupt-zmm.c
 create mode 100644 gcc/testsuite/gcc.target/i386/pr68637-1.c
 create mode 100644 gcc/testsuite/gcc.target/i386/pr68637-2.c

diff --git a/gcc/attribs.c b/gcc/attribs.c
index c18bff2..118db5a 100644
--- a/gcc/attribs.c
+++ b/gcc/attribs.c
@@ -513,9 +513,18 @@ decl_attributes (tree *node, tree attributes, int flags)
 	  flags &= ~(int) ATTR_FLAG_TYPE_IN_PLACE;
 	}
 
+      tree array_type = (TREE_CODE (*anode) == ARRAY_TYPE
+			 ? *anode
+			 : NULL_TREE);
+
       if (spec->function_type_required && TREE_CODE (*anode) != FUNCTION_TYPE
 	  && TREE_CODE (*anode) != METHOD_TYPE)
 	{
+	  /* We need to rebuid array with the updated function pointer
+	     type later. */
+	  if (array_type)
+	    *anode = TREE_TYPE (*anode);
+
 	  if (TREE_CODE (*anode) == POINTER_TYPE
 	      && (TREE_CODE (TREE_TYPE (*anode)) == FUNCTION_TYPE
 		  || TREE_CODE (TREE_TYPE (*anode)) == METHOD_TYPE))
@@ -636,7 +645,14 @@ decl_attributes (tree *node, tree attributes, int flags)
 	  if (fn_ptr_quals)
 	    fn_ptr_tmp = build_qualified_type (fn_ptr_tmp, fn_ptr_quals);
 	  if (DECL_P (*node))
-	    TREE_TYPE (*node) = fn_ptr_tmp;
+	    {
+	      if (array_type)
+		TREE_TYPE (*node)
+		  = build_array_type (fn_ptr_tmp,
+				      TYPE_DOMAIN (array_type));
+	      else
+		TREE_TYPE (*node) = fn_ptr_tmp;
+	    }
 	  else
 	    {
 	      gcc_assert (TREE_CODE (*node) == POINTER_TYPE);
diff --git a/gcc/config/i386/i386-protos.h b/gcc/config/i386/i386-protos.h
index 3962427..23152c3 100644
--- a/gcc/config/i386/i386-protos.h
+++ b/gcc/config/i386/i386-protos.h
@@ -279,6 +279,8 @@ extern rtx maybe_get_pool_constant (rtx);
 extern char internal_label_prefix[16];
 extern int internal_label_prefix_len;
 
+extern bool ix86_epilogue_uses (int);
+
 enum ix86_address_seg { SEG_DEFAULT, SEG_FS, SEG_GS };
 struct ix86_address
 {
